{
Cislo: 08
K programu patri jeste soubory:
topten.dat
topten.pas (+ *.dfm)
}
unit mainunit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  THraciPole = class(TForm)
    LJmeno1: TLabel;
    LJmeno2: TLabel;
    Shape1: TShape;
    Shape2: TShape;
    PStart: TPanel;
    Label1: TLabel;
    TrackBar1: TTrackBar;
    LPocet: TLabel;
    BStart: TButton;
    ImagePole: TImage;
    LBody1: TLabel;
    Lbody2: TLabel;
    BKonec: TButton;
    Button1: TButton;
    ISipka: TImage;
    LVyhra: TLabel;
    Button2: TButton;
    procedure TrackBar1Change(Sender: TObject);
    procedure BStartClick(Sender: TObject);
    procedure BKonecClick(Sender: TObject);
    procedure ImagePoleMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ImagePoleClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  HraciPole: THraciPole;

implementation

uses TopTen;

{$R *.DFM}
Var Jmeno1,Jmeno2: String; {Jmena hracu}
    Tah: boolean; {1.hrac - true, 2.hrac-false}
    MouseX,MouseY: Integer; {Pozice mysi na podlozce}
    pricteno: boolean; {Pomocna promenna}
    SirkyX,SirkyY: Array[1..11,1..10] of Boolean;
Const
  DelkaStrany=50;

Function MouseIN(x,y,x2,y2: integer): boolean; {Vraci True pokud je kurzor mysi mezi danymi souradnicemi}
Begin
  Result:=False;
  If (Mousex>=x)and(MouseX<=X2)and(Mousey>=y)and(MouseY<=y2) Then Result:=True;
End;

Function SouradniceIn(x,y,x1,y1,x2,y2: integer): boolean;
Begin
  Result:=False;
  If (x>=x1)and(X<=X2)and(y>=y1)and(Y<=y2) Then Result:=True;
End;

Procedure PrictiBod(x,y: integer); {Pricte bod hraci, ktery je na tahu}
var body1,body2: integer;
begin
  with hracipole do begin
    body1:=strtoint(Lbody1.caption);
    body2:=strtoint(Lbody2.caption);
    if tah then inc(body1) else inc(body2);
    lbody1.caption:=inttostr(body1);
    lbody2.caption:=inttostr(body2);
    if tah then imagepole.canvas.brush.Color:=clblue else imagepole.canvas.brush.Color:=clred;
        ImagePole.Canvas.floodfill((x-1)*delkastrany+2,(y-1)*delkastrany+2,clgreen,fssurface);
  end;
  pricteno:=true;
end;

Function Vsechno: boolean;             {Vraci true, pokud jsou uz vsechna mista plna}
Var X,y: Integer;
Begin
with hracipole do begin
  result:=True;
  For X:=1 To trackbar1.position+1 do
  For Y:=1 To trackbar1.position Do if not SirkyX[x,y] then result:=False;
  For Y:=1 To trackbar1.position+1 Do
  For X:=1 To trackbar1.position Do If not SirkyY[Y,X] Then result:=False;
end;
end;

Procedure Ctyri(X,Y: integer;svisle: boolean); {Zjisti hotovy ctverec}
Begin
  pricteno:=false;
  with hracipole do
  if svisle then begin
    if x=1 then begin
      if (sirkyx[1,y])and(sirkyx[2,y])and(sirkyy[y,1])and(sirkyy[y+1,1]) then PrictiBod(x,y);
    end
    else begin
      if (sirkyx[x,y])and(sirkyx[x+1,y])and(sirkyy[y,x])and(sirkyy[y+1,x]) then PrictiBod(x,y);
      if (sirkyx[x,y])and(sirkyx[x-1,y])and(sirkyy[y,x-1])and(sirkyy[y+1,x-1]) then PrictiBod(x-1,y);
    end;
  end else begin
    if y=1 then begin
      if (sirkyx[x,1])and(sirkyx[x+1,1])and(sirkyy[1,x])and(sirkyy[2,x]) then PrictiBod(x,y);
    end
    else begin
      if (sirkyx[x,y])and(sirkyx[x+1,y])and(sirkyy[y,x])and(sirkyy[y+1,x]) then PrictiBod(x,y);
      if (sirkyx[x,y-1])and(sirkyx[x+1,y-1])and(sirkyy[y,x])and(sirkyy[y-1,x]) then PrictiBod(x,y-1);
    end;
  end;
  if pricteno then Tah:=Not Tah;
End;

procedure THraciPole.TrackBar1Change(Sender: TObject);
begin
  LPocet.caption:=inttostr(trackbar1.position);
end;

procedure THraciPole.BStartClick(Sender: TObject);
Var X,Y: Integer;
begin
  {Inicializacni hodnoty}
  lbody1.caption:='0';
  lbody2.caption:='0';
  Lvyhra.visible:=false;
  BKonecClick(Self);
  TrackBar1.enabled:=false;
  BStart.enabled:=false;
  BKonec.enabled:=true;
  {Vykresleni hraciho pole:}
  ImagePole.Canvas.Brush.Color:=CLGreen;
  ImagePole.Canvas.Pen.Color:=CLBlack;
  ImagePole.Canvas.Rectangle(0,0,TrackBar1.Position*DelkaSTrany+2,TrackBar1.Position*DelkaSTrany+2);
  For Y:=0 to TrackBar1.Position-1 do begin
    For X:=0 to TrackBar1.Position-1 do
    ImagePole.Canvas.Rectangle(x*delkastrany+1,y*delkastrany+1,x*DelkaStrany+delkastrany+1,Y*DelkaStrany+delkastrany+1);
  end;
  {Vymazani vsech sirek:}
  For X:=1 To 11 Do
  For Y:=1 To 10 Do SirkyX[X,Y]:=False;
  For Y:=1 To 11 Do
  For X:=1 To 10 Do SirkyY[Y,X]:=False;
end;

procedure THraciPole.BKonecClick(Sender: TObject);
begin
  {Finalizacni hodnoty}
  ISipka.Visible:=false;
  BStart.enabled:=true;
  BKonec.enabled:=false;
  TrackBar1.Enabled:=True;
  {Uklid hraciho pole}
  ImagePole.Canvas.Brush.Color:=CLSilver;
  ImagePole.Canvas.Pen.Color:=CLSilver;
  ImagePole.Canvas.rectangle(0,0,ImagePole.width,ImagePole.Height)
end;

procedure THraciPole.ImagePoleMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  MouseX:=X;
  MouseY:=Y;
  ISipka.Visible:=False; {Pri pohybu mysi zmizi sipka (ukazatel pro klavesnici)}
end;

procedure THraciPole.ImagePoleClick(Sender: TObject);
Var X,Y: Integer;
    Cara: boolean;
    Hraci: array[1..10]of record
      jmeno: string;
      body: integer;
    end;
    t: textfile;
begin
  If MouseX<=TrackBar1.Position*DelkaStrany Then
  If MouseY<=TrackBar1.Position*DelkaStrany Then Begin
    If ImagePole.Canvas.Pixels[MouseX,MouseY]=CLBlack Then Begin
      Cara:=false;
      {Svisla cara}
      For X:=0 To 10 Do
      For Y:=0 To 9 Do
      If MouseIn(X*DelkaStrany,Y*DelkaStrany,X*Delkastrany+2,Y*Delkastrany+DelkaStrany) then begin
        ImagePole.Canvas.Pen.Color:=Clyellow;
        ImagePole.Canvas.rectangle(X*DelkaStrany,Y*DelkaStrany+1,X*Delkastrany+2,Y*Delkastrany+DelkaStrany);
        SirkyX[X+1,Y+1]:=True;
        Cara:=True;
        ctyri(x+1,y+1,true);{Byl sestrojen ctverec ?}
      end;
      {Vodorovna cara}
      If Not Cara Then
      For Y:=0 To 10 Do
      For X:=0 To 9 Do
      If MouseIn(X*DelkaStrany,Y*DelkaStrany,X*Delkastrany+DelkaStrany,Y*Delkastrany+2) then begin
        ImagePole.Canvas.Pen.Color:=Clyellow;
        ImagePole.Canvas.rectangle(X*DelkaStrany+1,Y*DelkaStrany,X*Delkastrany+DelkaStrany,Y*Delkastrany+2);
        SirkyY[Y+1,X+1]:=True;
        ctyri(x+1,y+1,false);
      end;
      Tah:=Not Tah; {Tahne druhy hrac}
      Shape1.Pen.Color:=CLBlack;
      Shape2.Pen.Color:=CLBlack;
      Case Tah of {Oznaceni hrace, ktery je prave na tahu}
        True: Shape1.Pen.Color:=clyellow;
        False: Shape2.Pen.Color:=clyellow;
      end;
      if vsechno then Begin {Pokud jsou vsechny sirky na stole:}
        If StrToInt(LBody1.caption)>StrToInt(LBody2.caption) then Lvyhra.caption:='Vyhrl '+Ljmeno1.caption
        else if StrToInt(LBody1.caption)<StrToInt(LBody2.caption) then Lvyhra.caption:='Vyhrl '+Ljmeno2.caption
        else Lvyhra.caption:='Remza'; {Kdo vyhral/remiza}
        Lvyhra.Show;
        try {Nacteni TopTen tabulky}
          assignfile(t,'topten.dat');
          reset(t);
          for x:=1 to 10 do begin
            readln(t,hraci[x].jmeno);
            readln(t,hraci[x].body);
          end;
          closefile(t);
          for x:=1 to 10 do
          if strtoint(lbody1.caption)>hraci[x].body then begin
            for y:=10 downto x+1 do hraci[y]:=hraci[y-1];
            hraci[x].jmeno:=ljmeno1.caption;
            hraci[x].body:=strtoint(lbody1.caption);
            break;
          end;
          for x:=1 to 10 do
          if strtoint(lbody2.caption)>hraci[x].body then begin
            for y:=10 downto x+1 do hraci[y]:=hraci[y-1];
            hraci[x].jmeno:=ljmeno2.caption;
            hraci[x].body:=strtoint(lbody2.caption);
            break;
          end;
          rewrite(t); {Zapsani TopTen Tabulky}
          for x:=1 to 10 do begin
            writeln(t,hraci[x].jmeno);
            writeln(t,hraci[x].body);
          end;
          closefile(t);
        except
          on EInOutError do messagedlg('Soubor TopTen.Dat nebyl nalezen !',mterror,[mbok],0);
        end;
      End;
    End;
  End;
end;

procedure THraciPole.Button1Click(Sender: TObject); {Zobrazi ovladani pres klavesnici}
begin
  ShowMessage('Nahoru - Q, Dol - A, Doleva - N, Doprava - M, Poloit - W');
end;

procedure THraciPole.FormKeyPress(Sender: TObject; var Key: Char);
{Ovladani klavesami}
Var X,x1,Y,y1: Integer;
    cara: boolean;
    var t: textfile;
    Hraci: array[1..10]of record
      jmeno: string;
      body: integer;
    end;
begin
If Not BStart.Enabled Then Begin {Funguje pouze, kdyz se hraje}
  X:=ISipka.Left;
  Y:=ISipka.Top;
  ISipka.Visible:=True;
  Case UpCase(Key) OF
    'Q': IF Y>ImagePole.Top+1 Then Dec(Y,25);
    'A': IF Y<TrackBar1.Position*DelkaStrany+DelkaStrany+25 Then Inc(Y,25);
    'N': IF X>ImagePole.Left+1 Then Dec(X,25);
    'M': IF X<TrackBar1.Position*DelkaStrany Then Inc(X,25);
    'W': Begin
          {Polozeni sirky - totozne s kliknutim mysi, az na par radku ...}
           cara:=false;
           X1:=X; Y1:=Y;
           If ImagePole.Canvas.Pixels[X-ImagePole.Left,Y-ImagePole.Top]=CLBlack Then Begin
           For X:=0 To 10 Do
           For Y:=0 To 9 Do
           If SouradniceIn(X1-ImagePole.Left,Y1-ImagePole.Top,X*DelkaStrany,Y*DelkaStrany,X*Delkastrany+2,Y*Delkastrany+DelkaStrany) then begin
             ImagePole.Canvas.Pen.Color:=Clyellow;
             ImagePole.Canvas.rectangle(X*DelkaStrany,Y*DelkaStrany+1,X*Delkastrany+2,Y*Delkastrany+DelkaStrany);
             SirkyX[X+1,Y+1]:=True;
             cara:=true;
             ctyri(x+1,y+1,true);
           end;
           if not cara then
           For Y:=0 To 10 Do
           For X:=0 To 9 Do
           If SouradniceIn(X1-ImagePole.Left,Y1-ImagePole.Top,X*DelkaStrany,Y*DelkaStrany,X*Delkastrany+DelkaStrany,Y*Delkastrany+2) then begin
            ImagePole.Canvas.Pen.Color:=Clyellow;
            ImagePole.Canvas.rectangle(X*DelkaStrany+1,Y*DelkaStrany,X*Delkastrany+DelkaStrany,Y*Delkastrany+2);
            Sirkyy[y+1,x+1]:=True;
            ctyri(x+1,y+1,false);
          end;
          Tah:=Not Tah;
          Shape1.Pen.Color:=CLBlack;
          Shape2.Pen.Color:=CLBlack;
          Case Tah of
            True: Shape1.Pen.Color:=clyellow;
            False: Shape2.Pen.Color:=clyellow;
          end;
          X:=X1;
          Y:=Y1;
          if vsechno then Begin
          If StrToInt(LBody1.caption)>StrToInt(LBody2.caption) then Lvyhra.caption:='Vyhrl '+Ljmeno1.caption
          else if StrToInt(LBody1.caption)<StrToInt(LBody2.caption) then Lvyhra.caption:='Vyhrl '+Ljmeno2.caption
          else Lvyhra.caption:='Remza';
          Lvyhra.Show;
          try {Nacteni TopTen tabulky}
            assignfile(t,'topten.dat');
            reset(t);
            for x:=1 to 10 do begin
              readln(t,hraci[x].jmeno);
              readln(t,hraci[x].body);
            end;
            closefile(t);
            for x:=1 to 10 do
            if strtoint(lbody1.caption)>hraci[x].body then begin
              for y:=10 downto x+1 do hraci[y]:=hraci[y-1];
              hraci[x].jmeno:=ljmeno1.caption;
              hraci[x].body:=strtoint(lbody1.caption);
              break;
            end;
            for x:=1 to 10 do
            if strtoint(lbody2.caption)>hraci[x].body then begin
              for y:=10 downto x+1 do hraci[y]:=hraci[y-1];
              hraci[x].jmeno:=ljmeno2.caption;
              hraci[x].body:=strtoint(lbody2.caption);
              break;
            end;
            rewrite(t); {Zapsani TopTen Tabulky}
            for x:=1 to 10 do begin
              writeln(t,hraci[x].jmeno);
              writeln(t,hraci[x].body);
            end;
          closefile(t);
        except
          on EInOutError do messagedlg('Soubor TopTen.Dat nebyl nalezen !',mterror,[mbok],0);
        end;
        End;
        End;
      End;
  End;
  ISipka.Left:=X;
  ISIpka.Top:=Y;
End;
end;

procedure THraciPole.Button2Click(Sender: TObject);
begin
  TopTenForm.Show; {Zobrazeni TopTen tabulky}
end;

procedure THraciPole.FormCreate(Sender: TObject); {Start programu}
begin
  Jmeno1:='Pepa';
  Jmeno2:='Honza';
  inputquery('Jmno hre','Zadej jmno 1. hre:',jmeno1);
  inputquery('Jmno hre','Zadej jmno 2. hre:',jmeno2);
  LJmeno1.Caption:=jmeno1;
  LJmeno2.caption:=jmeno2;
  Tah:=true;
end;

end.
